#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdarg.h>

#include "SDL.h"
#include "StandardHandleEvent.h"
#include "config.h"


void StandardHandleEvent(onKeyDown_func onKeyDown, onIdle_func onIdle)
{
  SDL_Event event;
  SDLKey key;
  int RepeatKey = -1, RepeatCount=-1;
  Uint32 RepeatTicks = -1;
  Uint8 *KeyState;

  while(1)
  {
    if(RepeatKey != -1)
    {
      KeyState = SDL_GetKeyState(NULL);
      if(KeyState[RepeatKey] == 0)
        RepeatKey = -1;
      else
      {
      	int Passed = SDL_GetTicks() - RepeatTicks;
      	int Delay = RepeatCount == 0 ? Config.RepeatDelay : Config.RepeatRate;

      	if(Passed > Delay)
      	{
      		RepeatTicks = SDL_GetTicks();
      		key = RepeatKey;
        	++RepeatCount;
      		
      		goto RepeatLoc;
      	}
      }
    }
    
	  while ( SDL_PollEvent(&event) )
	  {
	  	if(event.type == SDL_KEYDOWN)
	  	{
		    key = event.key.keysym.sym;

		    RepeatKey = key;  
		    RepeatTicks = SDL_GetTicks();
		    RepeatCount = 0;

        KeyState = SDL_GetKeyState(NULL);
		    
RepeatLoc:	
        if(onKeyDown)
        {
          if(onKeyDown(key, KeyState))
            return;
        }
	  	}
	  }
    if(onIdle) onIdle();
  }
}
